import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;
import java.io.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

class blobaccess {
  //static int count = 0;

  public static void main(String argv[]) {
    try {
      String url = "jdbc:oracle:thin:@aspen.csit.fsu.edu:1521:aspen";
      String query, condition;
      int	i;
      //byte[] bytes;

      Class.forName( "oracle.jdbc.driver.OracleDriver" ); 

      System.out.println("Please enter information to connection to the database");
      String user;
      String password;

      user = readEntry ("user: ");
      password = readEntry ("password: ");

      Connection conn = 
        DriverManager.getConnection(url, user, password);

      Statement stat = conn.createStatement();

      BLOB blob;
      
      query = "select * from xmltest";
      ResultSet rs = stat.executeQuery(query);

      while ( rs.next() ) {
        int index = ((OracleResultSet)rs).getInt(1);
        blob = ((OracleResultSet)rs).getBLOB(2);

        int length = (int)blob.length();

        System.out.println("blob length " + length);
        
        byte[] bytes = blob.getBytes(1,length);
        for (i=0; i<length; i++)
          System.out.print((char)bytes[i]);
        System.out.println("***************************");
        printXMLDocument(bytes, length);
        System.out.println("\n---------------------------");
      }

      conn.close();
      System.out.println("End of BLOB access");
    } catch ( Exception e ) {
      System.err.println("Exception: "+e);
      e.printStackTrace();
    }
  }

  static String readEntry (String prompt) {
    try {
      StringBuffer buffer = new StringBuffer();
      System.out.print (prompt);
      System.out.flush();
      int c = System.in.read();
      while (c != '\n' && c !=-1) {
        buffer.append ((char)c);
        c = System.in.read();
      }
      return buffer.toString().trim();
    }
    catch (IOException e) {
      return "";
    }
  }

  static void printXMLDocument (byte[] bytes, int length) {

    ByteArrayInputStream is = new ByteArrayInputStream(bytes, 0, length-1);

    /*if (count != 0)
      for(int i=0; i<length; i++)
        System.out.print((char)bytes[i]);
    count++;*/
    //if (count !=0)
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = dbf.newDocumentBuilder();
      Document doc = db.parse( is );

      TransformerFactory tFactory =
        TransformerFactory.newInstance();
      Transformer tf = tFactory.newTransformer();

      DOMSource source = new DOMSource(doc);
      StreamResult result = new StreamResult(System.out);
      tf.transform(source, result);
      is.close();
    }
    catch (Exception e) {
      System.out.println(e.getMessage());
    }
    //count++;
  }
}
